/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

static void book_autoshow(GtkWidget *widget, gpointer data)
{
	if(g_list_length((GTK_NOTEBOOK(widget))->children) > 0) {
		gtk_widget_show(widget);
	} else {
		gtk_widget_hide(widget);
	}
}

DUMP_DEF(Book)
{
}

HANDLE_DEF(Book)
{
	GtkObject *notebook;
	char *id = (char*)g_list_nth_data(args, 0);

	g_return_val_if_fail(id != NULL, NULL);

	notebook = (GtkObject*) gtk_notebook_new();
#if 1
	gtk_signal_connect(notebook, "map",
			   GTK_SIGNAL_FUNC(book_autoshow), NULL);
	gtk_signal_connect(notebook, "add",
			   GTK_SIGNAL_FUNC(book_autoshow), NULL);
	gtk_signal_connect(notebook, "remove",
			   GTK_SIGNAL_FUNC(book_autoshow), NULL);
#endif
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(notebook), TRUE);

        gtk_object_set_data(notebook, GNOME_LINUXCONF_HINT_HPAD,
                            GINT_TO_POINTER(0));
        gtk_object_set_data(notebook, GNOME_LINUXCONF_HINT_VPAD,
                            GINT_TO_POINTER(0));

	gtk_signal_connect(parents_peek(), "dump",
			   GTK_SIGNAL_FUNC(dump_object), notebook);

	parent_insert(NULL, notebook);
	parents_push(GTK_OBJECT(notebook));
	register_object_with_parent(notebook, id);

	return notebook;
}
