/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Checkbox)
{
	const char *cname = get_object_relative_name(dumpee);
	char *name, *c;
	gboolean cb;

	cb = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dumpee));

	g_return_if_fail(cname != NULL);
	name = g_strdup(cname);
	c = strrchr(name, '.');

	if(c != NULL) {
		*c++ = '\0';
#ifdef DEBUG
		printf ("dump %s %s %d\n", name, c, cb ? 1 : 0);
#endif
		g_print("dump %s %s %d\n", name, c, cb ? 1 : 0);
	}

	g_free(name);
}

HANDLE_DEF(Checkbox)
{
	GtkObject *checkbox;
	char *id = (char*)g_list_nth_data(args, 0);
	char *value = g_list_nth_data(args, 1);
	char *title = (char*)g_list_nth_data(args, 2);

	g_return_val_if_fail(id != NULL, NULL);
	g_return_val_if_fail(value != NULL, NULL);
	g_return_val_if_fail(title != NULL, NULL);

	checkbox = (GtkObject*) gtk_check_button_new_with_label(title);
	if((value != NULL) && (atoi(value) != 0)) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), TRUE);
	}

	gtk_object_set_data(checkbox, GNOME_LINUXCONF_HINT_VFLAGS,
			    GINT_TO_POINTER(GTK_SHRINK));
	gtk_object_set_data(checkbox, GNOME_LINUXCONF_HINT_VPAD,
			    GINT_TO_POINTER(-1));

	gtk_signal_connect(parents_peek(), "dump",
			   GTK_SIGNAL_FUNC(dump_object), checkbox);

	parent_insert(NULL, checkbox);
	register_object_with_parent(checkbox, id);
	
	return checkbox;
}

SETVAL_DEF(Checkbox)
{
        const char *pid = (const char*) g_list_nth_data(args, 0);
        const char *id = (const char*) g_list_nth_data(args, 1);
	const char *state = (const char*) g_list_nth_data(args, 2);
	GtkObject *object;
	g_return_if_fail(state != NULL);
	object = get_object_by_name_with_parent(strlen(pid)>0?pid:NULL,id);
	g_return_if_fail(GTK_IS_TOGGLE_BUTTON(object));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(object), atoi(state));
}
