/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

/* A widget has all of its children visible now.  So show it. */
HANDLE_DEF(End)
{
	/* If we're in a tree, pop the tree, otherwise, pop an object. */
	if(tree_peek() != NULL) {
		tree_pop();
	} else {
		GtkObject *parent = parents_pop();
		GtkObject *mainform = mainforms_peek();
		const char *nopopup = g_hash_table_lookup(opts, "nopopup");
		if(GTK_IS_OBJECT(parent)) {
			int type = get_object_type(parent);
			previous_object = parent;
			if(parent == mainform) {
				mainforms_pop();
				if (type == TYPE_POPUPMENU) {
					gtk_menu_popup(GTK_MENU(parent),NULL,
						       NULL,NULL,NULL,2,
						       GDK_CURRENT_TIME);
				}
				if (GTK_IS_WIDGET(parent)
				    && (nopopup == NULL || *nopopup != '1')){
					gtk_widget_show_all(GTK_WIDGET(parent)->parent);
				}
			} else if (GTK_IS_WIDGET(parent)
			           && (nopopup == NULL || *nopopup != '1')) {
				gtk_widget_show_all(GTK_WIDGET(parent));
			}
		}
	}
	return NULL;
}
