/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"
#define GAUGE_HEIGHT 20

DUMP_DEF(Gauge)
{
}

HANDLE_DEF(Gauge)
{
	GtkWidget *widget = NULL;
	char *id = (char*)g_list_nth_data(args, 0);
	char *width = (char*)g_list_nth_data(args, 1);
	char *range = (char*)g_list_nth_data(args, 2);
	char *value = (char*)g_list_nth_data(args, 3);

	g_return_val_if_fail(id != NULL, NULL);
	g_return_val_if_fail(width != NULL, NULL);
	g_return_val_if_fail(range != NULL, NULL);
	g_return_val_if_fail(value != NULL, NULL);

	widget = gtk_progress_bar_new();
	gtk_progress_configure(GTK_PROGRESS(widget), atof(value),
		       	       0, atof(range));
	gtk_widget_set_usize(GTK_WIDGET(widget), atoi(width), GAUGE_HEIGHT);
	
	gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_VFLAGS,
			    GINT_TO_POINTER(GTK_SHRINK));

	parent_insert(NULL, GTK_OBJECT(widget));

	register_object_with_parent(GTK_OBJECT(widget), id);
	
	return GTK_OBJECT(widget);
}


SETVAL_DEF(Gauge)
{
        const char *pid = (const char*) g_list_nth_data(args, 0);
        const char *id = (const char*) g_list_nth_data(args, 1);
	const char *value = (const char*) g_list_nth_data(args, 2);
	GtkObject *object;
	g_return_if_fail(value != NULL);
	object = get_object_by_name_with_parent(strlen(pid)>0?pid:NULL,id);
	g_return_if_fail(GTK_IS_PROGRESS(object));
	gtk_progress_set_value(GTK_PROGRESS(object), atof(value));
}
