/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Group)
{
}

HANDLE_DEF(Group)
{
	GtkWidget *widget = NULL;
	char *id = (char*)g_list_nth_data(args, 0);
	
	g_return_val_if_fail(id != NULL, NULL);

	widget = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(widget), GTK_SHADOW_NONE);

	gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_HPAD,
			    GINT_TO_POINTER(-1));
	gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_VPAD,
			    GINT_TO_POINTER(-1));

	gtk_signal_connect(parents_peek(), "dump",
			   GTK_SIGNAL_FUNC(dump_object), GTK_OBJECT(widget));

	parent_insert(NULL, GTK_OBJECT(widget));
	parents_push(GTK_OBJECT(widget));
	register_object_with_parent(GTK_OBJECT(widget), id);

	return GTK_OBJECT(widget);
}

DUMP_DEF(Groupfit)
{
}

HANDLE_DEF(Groupfit)
{
	return handle_Group(args,opts);
}
