/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include <gtk/gtk.h>
#include "gtkgeneric.h"

static void gtk_generic_class_init(GtkGenericClass *class);
static void gtk_generic_init (GtkGeneric *generic);

GtkType
gtk_generic_get_type (void)
{ 
  static GtkType generic_type = 0;
  
  if (!generic_type)
    {
      static const GtkTypeInfo generic_info =
      { 
        "GtkGeneric",
        sizeof (GtkGeneric),
        sizeof (GtkGenericClass),
        (GtkClassInitFunc) gtk_generic_class_init, 
        (GtkObjectInitFunc) gtk_generic_init,
        /* reserved_1 */ NULL,
        /* reserved_2 */ NULL,
        (GtkClassInitFunc) NULL,
      };
       
      generic_type = gtk_type_unique (gtk_object_get_type (), &generic_info);
    }
  
  return generic_type;
}

static void
gtk_generic_class_init(GtkGenericClass *class)
{
}

static void
gtk_generic_init (GtkGeneric *generic)
{
}

GtkObject*
gtk_generic_new (GtkObject *parent)
{
  GtkGeneric *generic;
  generic = gtk_type_new (gtk_generic_get_type ());
  generic->parent = parent;
  return GTK_OBJECT(generic);
} 

