/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Hline)
{
}

HANDLE_DEF(Hline)
{
	GtkWidget *widget = NULL, *label = NULL;
	char *text = concat_strings(args);

	widget = gtk_hbox_new(FALSE, 0);

	gtk_box_pack_start(GTK_BOX(widget), gtk_hseparator_new(),
			   TRUE, TRUE, 0);

	if(strlen(text) > 0) {
		label = gtk_label_new(text);
		gtk_signal_connect(GTK_OBJECT(label), "destroy",
				   GTK_SIGNAL_FUNC(free_data), text);

		gtk_box_pack_start(GTK_BOX(widget), label,
			       	   FALSE, FALSE, GNOME_PAD_SMALL);

		gtk_box_pack_start(GTK_BOX(widget), gtk_hseparator_new(),
				   TRUE, TRUE, 0);
	} else {
		g_free(text);
	}

	parent_insert(NULL, GTK_OBJECT(widget));

	return GTK_OBJECT(widget);
}
