/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Icon_xpm)
{
}

HANDLE_DEF(Icon_xpm)
{
	GtkWidget *widget, *pm;
	GdkPixmap *pixmap;
	GdkBitmap *bitmap;

	char *id = (char*)g_list_nth_data(args, 0);

	g_return_val_if_fail(id != NULL, NULL);

	pm = (GtkWidget*) get_xpm_object_by_name(id);
	g_return_val_if_fail(GTK_IS_PIXMAP(pm), NULL);
	gtk_pixmap_get(GTK_PIXMAP(pm),&pixmap,&bitmap);
	widget = gtk_pixmap_new(pixmap,bitmap);
	
        gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_HFLAGS,
                            GINT_TO_POINTER(GTK_SHRINK));
        gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_VFLAGS,
                            GINT_TO_POINTER(GTK_SHRINK));
        gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_HPAD,
                            GINT_TO_POINTER(5));
        gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_VPAD,
                            GINT_TO_POINTER(5));
	
	parent_insert(NULL, GTK_OBJECT(widget));

	return GTK_OBJECT(widget);
}
