/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Label)
{
}

HANDLE_DEF(Label)
{
	GtkObject *label;
	const char *title = (const char*) g_list_nth_data(args, 0);
	const char *id =  g_hash_table_lookup(opts, "id");
	char *dtitle;

	g_return_val_if_fail(title != NULL, NULL);

	dtitle = g_strdup(strlen(title) ? title : " ");
	label = (GtkObject*) gtk_label_new(dtitle);
	gtk_signal_connect(label, "destroy",
			   GTK_SIGNAL_FUNC(free_data), dtitle);

	gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);
	gtk_label_set_line_wrap(GTK_LABEL(label), FALSE);

	gtk_object_set_data(label, GNOME_LINUXCONF_HINT_VFLAGS,
			    GINT_TO_POINTER(GTK_FILL));
	gtk_object_set_data(label, GNOME_LINUXCONF_HINT_HFLAGS,
			    GINT_TO_POINTER(GTK_FILL));
	gtk_object_set_data(label, GNOME_LINUXCONF_HINT_VPAD,
			    GINT_TO_POINTER(-1));

	parent_insert(NULL, label);
	if (id != NULL)
		register_object_with_parent(label, id);

	return label;
}

SETVAL_DEF(Label)
{
        const char *pid = (const char*) g_list_nth_data(args, 0);
        const char *id = (const char*) g_list_nth_data(args, 1);
	const char *text = (const char*) g_list_nth_data(args, 2);
	GtkObject *object;
	g_return_if_fail(text != NULL);
	object = get_object_by_name_with_parent(strlen(pid)>0?pid:NULL,id);
	g_return_if_fail(GTK_IS_LABEL(object));
	gtk_label_set_text(GTK_LABEL(object), text);
}
