/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Page)
{
}

HANDLE_DEF(Page)
{
	GtkWidget *widget, *label1, *label2, *notebook;
	char *id = (char*)g_list_nth_data(args, 0);
	char *title = (char*)g_list_nth_data(args, 1);
	
	g_return_val_if_fail(id != NULL, NULL);
	g_return_val_if_fail(title != NULL, NULL);

	notebook = (GtkWidget*) parents_peek();
	g_return_val_if_fail(GTK_IS_NOTEBOOK(notebook), NULL);
	
	widget = gtk_vbox_new(FALSE, 0);

	title = g_strdup(title);
	label1 = gtk_label_new(title);
	gtk_signal_connect(GTK_OBJECT(label1), "destroy",
			   GTK_SIGNAL_FUNC(free_data), title);

	title = g_strdup(title);
	label2 = gtk_label_new(title);
	gtk_signal_connect(GTK_OBJECT(label2), "destroy",
			   GTK_SIGNAL_FUNC(free_data), title);

	gtk_notebook_append_page_menu(GTK_NOTEBOOK(notebook),
				      widget, label1, label2);

	gtk_signal_connect(parents_peek(), "dump",
			   GTK_SIGNAL_FUNC(dump_object), GTK_OBJECT(widget));
	
	parents_push(GTK_OBJECT(widget));
	register_object_with_parent(GTK_OBJECT(widget), id);

	return GTK_OBJECT(widget);
}
