/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Password)
{
	const char *text = gtk_entry_get_text(GTK_ENTRY(dumpee));
	const char *cname = get_object_relative_name(dumpee);
       	char *name, *c;

	g_return_if_fail(text != NULL);
	g_return_if_fail(cname != NULL);

	if((text == NULL) || (strlen(text) == 0)) {
		return;
	}

	name = g_strdup(cname);
	c = strrchr(name, '.');
	if(c != NULL) {
		*c++ = '\0';
#ifdef DEBUG
		printf("dump %s %s %s\n", name, c, text);
#endif
		g_print("dump %s %s %s\n", name, c, text);
	}

	g_free(name);
}

HANDLE_DEF(Password)
{
	GtkObject *password = NULL;
	char *id = (char*)g_list_nth_data(args, 0);
	char *text = (char*)g_list_nth_data(args, 2);

	g_return_val_if_fail(id != NULL, NULL);
	g_return_val_if_fail(text != NULL, NULL);

	password = (GtkObject*) gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(password), text);
	gtk_entry_set_visibility(GTK_ENTRY(password), FALSE);
	
	gtk_signal_connect(parents_peek(), "dump",
			   GTK_SIGNAL_FUNC(dump_object), password);

	parent_insert(NULL, password);
	register_object_with_parent(password, id);

	return password;
}
