#ifndef registries_h
#define registries_h

extern GtkObject *previous_object;

void unregister_object(GtkObject *object, const char *cid);
const char *get_object_name(GtkObject *object);
const char *get_object_base_name(GtkObject *object);
const char *get_object_relative_name(GtkObject *object);
char *get_object_path(GtkObject *object);
int get_object_type(GtkObject *object);
void register_object_with_parent(GtkObject *object, const char *id);
void register_object(GtkObject *object, const char *path, const char *id);
GtkObject *get_object_by_name(const char *cid);
GtkObject *get_object_by_name_with_parent(const char *parentid, const char *id);
GtkObject *get_object_mainform(GtkObject *object);

void unregister_xpm_object(GtkObject *object, const char *id);
void register_xpm_object(GtkObject *object, const char *id);
GtkObject *get_xpm_object_by_name(const char *id);

GtkObject *parents_push(GtkObject *new_parent);
GtkObject *parents_pop(void);
GtkObject *parents_peek(void);

GtkObject *mainforms_push(GtkObject *new_mainform);
GtkObject *mainforms_pop(void);
GtkObject *mainforms_peek(void);

GtkCTreeNode *tree_push(GtkCTreeNode *new_parent);
GtkCTreeNode *tree_pop(void);
GtkCTreeNode *tree_peek(void);

int window_list_length(void);
void window_list_add(GtkWidget *window, gpointer ignored);
void window_list_remove(GtkWidget *window, gpointer ignored);
void window_list_unbusy_all(GtkWidget *window, gpointer ignored);
void window_list_busy_all(GtkWidget *window, gpointer ignored);

#endif
