/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

HANDLE_DEF(Setval)
{
        const char *pid = (const char*) g_list_nth_data(args, 0);
        const char *id = (const char*) g_list_nth_data(args, 1);
	char *cid;
	int type;

	GtkObject *object = NULL;
	
	/* If it's an empty string, then use the current parent. */
	if (strlen(pid) == 0) {
		pid = get_object_name(parents_peek());
	}
	cid = g_strdup_printf("%s.%s", pid, id);
	object = get_object_by_name(cid);
	g_free(cid);

	if (!GTK_IS_OBJECT(object)) {
		g_warning("Object \"%s.%s\" not found.", pid, id);
		return NULL;
	}
	
	type = get_object_type(object);

	if (type == -1) {
		g_warning("Unknown type for object \"%s.%s\".", pid, id);
	} else {
		command_setval_fn *setval = commands[type].setval;
		if (setval != NULL) {
			setval(args,opts);
		} else {
			g_warning("Setval not defined for %s objects (\"%s.%s\").",
				  commands[type].name, pid, id);
		}
	}

	return NULL;
}
