/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(Slider)
{
}

HANDLE_DEF(Slider)
{
	GtkObject *adjustment = NULL;
	GtkWidget *widget = NULL;

	char *id = (char*)g_list_nth_data(args, 0);
	char *minval = (char*)g_list_nth_data(args, 0);
	char *maxval = (char*)g_list_nth_data(args, 0);

	g_return_val_if_fail(id != NULL, NULL);

	adjustment = gtk_adjustment_new(atof(minval),
		       			atof(minval),
					atof(maxval),
					1.0, 1.0, 1.0);
	widget = gtk_hscale_new(GTK_ADJUSTMENT(adjustment));
	
	parent_insert(NULL, GTK_OBJECT(widget));
	register_object_with_parent(GTK_OBJECT(widget), id);

	return GTK_OBJECT(widget);
}
