/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"
#include "splash.xpm"

static GtkWidget *current_splash = NULL;

HANDLE_DEF(Splash)
{
	GtkWidget *window, *pm;
	GdkPixmap *pixmap;
	GdkBitmap *bitmap;
	const char *xpm = g_hash_table_lookup(opts,"xpm");
	
	if (xpm) {
		pm = (GtkWidget*) get_xpm_object_by_name(xpm);
		g_return_val_if_fail(GTK_IS_PIXMAP(pm), NULL);
		gtk_pixmap_get(GTK_PIXMAP(pm),&pixmap,&bitmap);
		pm = gtk_pixmap_new(pixmap,bitmap);
	} else {
		pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL,
				gtk_widget_get_default_colormap(),
				&bitmap,NULL,splash_data);
		pm = gtk_pixmap_new(pixmap,bitmap);
	}

	if (current_splash) gtk_widget_destroy(current_splash);

	current_splash = gtk_window_new(GTK_WINDOW_POPUP);
	gtk_container_add(GTK_CONTAINER(current_splash), pm);
	gtk_window_set_modal(current_splash, TRUE);
	gtk_window_set_position(current_splash, GTK_WIN_POS_CENTER);
	gtk_widget_show_all(current_splash);

	return NULL;
}

HANDLE_DEF(Hidesplash)
{
	if (current_splash) gtk_widget_destroy(current_splash);
	current_splash = NULL;
	return NULL;
}
