/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

char *str_accumulator = NULL;

HANDLE_DEF(Str)
{
	char *text = concat_strings(args);
	GtkObject *parent = parents_peek();

	g_return_val_if_fail(text != NULL, NULL);

	if (GTK_IS_TEXT(parent)) {
		gtk_editable_insert_text(GTK_EDITABLE(parent),
					 text,
					 strlen(text),
					 &textarea_position);
		gtk_editable_insert_text(GTK_EDITABLE(parent),
					 "\n",
					 1,
					 &textarea_position);
	} else if (str_accumulator != NULL) {
		char *newacc = g_strconcat(str_accumulator,
					   text, "\n", NULL);
		g_free(str_accumulator);
		g_free(text);
		str_accumulator = newacc;
	} else {
		char *newacc = g_strconcat(text, "\n", NULL);
		g_free(text);
		str_accumulator = newacc;
	}

	return NULL;
}
