/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

DUMP_DEF(String)
{
	dump_Password(dumpee, data);
}

HANDLE_DEF(String)
{
	GtkWidget *widget = NULL;
	char *id = (char*)g_list_nth_data(args, 0);
	/* Unused. (GN) */
	/* char *width = (char*)g_list_nth_data(args, 1); */
	char *text = (char*)g_list_nth_data(args, 2);

	g_return_val_if_fail(id != NULL, NULL);

	widget = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(widget), text ? text : "");
	
	gtk_object_set_data(GTK_OBJECT(widget), GNOME_LINUXCONF_HINT_VFLAGS,
			    GINT_TO_POINTER(GTK_FILL));
	
	gtk_widget_set_usize(GTK_WIDGET(widget), 55, -1);

	gtk_signal_connect(parents_peek(), "dump",
			   GTK_SIGNAL_FUNC(dump_object), GTK_OBJECT(widget));

	parent_insert(NULL, GTK_OBJECT(widget));
	register_object_with_parent(GTK_OBJECT(widget), id);

	return GTK_OBJECT(widget);
}

SETVAL_DEF(String)
{
        const char *pid = (const char*) g_list_nth_data(args, 0);
        const char *id = (const char*) g_list_nth_data(args, 1);
	const char *text = (const char*) g_list_nth_data(args, 2);
	GtkObject *object;
	g_return_if_fail(text != NULL);
	object = get_object_by_name_with_parent(strlen(pid)>0?pid:NULL,id);
	g_return_if_fail(GTK_IS_ENTRY(object));
	gtk_entry_set_text(GTK_ENTRY(object), text);
}
