/*
 * A GTK+/GNOME front end for Linuxconf.
 *
 * Copyright (C) 2000, 2001 Conectiva, Inc.
 * Copyright (C) 2000 Red Hat, Inc.
 *
 * Authors: Gustavo Niemeyer <niemeyer@conectiva.com>
 *          Nalin Dahyabhai <nalin@redhat.com>
 *
 */

#include "gnome-linuxconf.h"

static char *jump_c_comment(char *p)
{
	if (*p == '/' && *(p+1) == '*') {
		p += 2;
		for (;;p++) {
			if (*p == '0')
				return p;
			if (*p == '*' && *(p+1) == '/')
				return p+2;
		}
	}
	return p;
}


HANDLE_DEF(Xfer_xpm)
{
	GtkWidget *widget = NULL;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	char *xpmv[1024];
	char *p;
	char *id = (char*)g_list_nth_data(args, 0);
	int i = 0;
	gboolean verify = FALSE;

	g_return_val_if_fail(id != NULL, NULL);
	g_return_val_if_fail(str_accumulator != NULL, NULL);
	
	/* Now look for the first '{', jumping comments. (GN) */
	for (p = str_accumulator; *p != '{' && *p != 0; p++)
		p = jump_c_comment(p);
	g_return_val_if_fail(*p != 0, NULL);
	
	p = str_accumulator;
	
	for(;;) {
		/* Look for the first '"', jumping comments. (GN) */
		for (; *p != '"' && *p != '}' && *p != 0; p++)
			p = jump_c_comment(p);
		if (*p == 0) break;

		if (*p == '}') {
			verify = TRUE;
			break;
		}
		
		xpmv[i++] = ++p;

		/* And look for the ending '"'. (GN) */
		for (; *p != '"' && *p != 0; p++)
			if (*p == '\\' && *(p+1) != 0) p+=2;
		if (*p == 0) break;

		*p++ = 0;
	}

	/* Do some sanity checking. (GN) */
	g_return_val_if_fail(i > 0, NULL);
	g_return_val_if_fail(verify == TRUE, NULL);
	
	xpmv[i] = NULL;
	
	pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL,
			gtk_widget_get_default_colormap(),&mask,NULL,xpmv);
	widget = gtk_pixmap_new(pixmap,mask);

	g_free(str_accumulator);
	str_accumulator = NULL;

	register_xpm_object(GTK_OBJECT(widget), id);

	return GTK_OBJECT(widget);
}
